diff --git a/gnu/build/icecat-extension.scm b/gnu/build/icecat-extension.scm
new file mode 100644
index 000000000000..ccc6a1ece7fb
--- /dev/null
+++ b/gnu/build/icecat-extension.scm
@@ -0,0 +1,62 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright © 2020, 2021 Marius Bakke <marius@gnu.org>
+;;; Copyright © 2023 Clément Lassieur <clement@lassieur.org>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (gnu build icecat-extension)
+  #:use-module (guix gexp)
+  #:use-module (guix packages)
+  #:use-module (guix build-system trivial)
+  #:export (make-icecat-extension))
+
+(define* (make-icecat-extension pkg #:optional (pkg-output "out"))
+  "Create an Icecat extension from package PKG and return a package that,
+when installed, will make the extension contained in PKG available as an
+Icecat browser extension.  PKG-OUTPUT specifies which output of PKG to use."
+  (package
+    (inherit pkg)
+    (name (string-append (package-name pkg) "-icecat"))
+    (native-inputs '())
+    (inputs '())
+    (propagated-inputs '())
+    (outputs '("out"))
+    (build-system trivial-build-system)
+    (arguments
+     (list
+      #:modules '((guix build utils))
+      #:builder
+      #~(begin
+          (use-modules (guix build utils))
+          (let* ((id #$(assq-ref (package-properties pkg) 'id))
+                 (moz-app-id "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}")
+                 (search-dir (string-append #$output
+                                            "/share/icecat/extensions/"
+                                            moz-app-id)))
+            ;; Icecat's XPIProvider.jsm looks within `search-dir` for a
+            ;; directory named after the add-on id.
+
+            ;; This directory has to be a symlink, because Icecat's
+            ;; GetNativeTarget checks S_ISLNK before canonicalizing it like
+            ;; `readlink -f` would do.
+
+            ;; Canonicalizing is required because Icecat compares the path
+            ;; against its local database to know if there is an extension
+            ;; update.  A path that contains the store path will change every
+            ;; time the package is updated.
+            (mkdir-p search-dir)
+            (symlink (in-vicinity (ungexp pkg pkg-output) id)
+                     (in-vicinity search-dir id))))))))
diff --git a/gnu/local.mk b/gnu/local.mk
index a53701c673b7..17916a106dfb 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -13,7 +13,7 @@
 # Copyright © 2016-2023 Efraim Flashner <efraim@flashner.co.il>
 # Copyright © 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
 # Copyright © 2017, 2018, 2019, 2020 Tobias Geerinckx-Rice <me@tobias.gr>
-# Copyright © 2017, 2018 Clément Lassieur <clement@lassieur.org>
+# Copyright © 2017, 2018, 2023 Clément Lassieur <clement@lassieur.org>
 # Copyright © 2017, 2020 Mathieu Othacehe <m.othacehe@gmail.com>
 # Copyright © 2017, 2018, 2019 Gábor Boskovits <boskovits@gmail.com>
 # Copyright © 2018 Amirouche Boubekki <amirouche@hypermove.net>
@@ -759,6 +759,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/build/chromium-extension.scm		\
   %D%/build/cross-toolchain.scm			\
   %D%/build/dbus-service.scm			\
+  %D%/build/icecat-extension.scm		\
   %D%/build/image.scm				\
   %D%/build/jami-service.scm			\
   %D%/build/file-systems.scm			\
@@ -1406,6 +1407,8 @@ dist_patch_DATA =						\
   %D%/packages/patches/icecat-makeicecat.patch			\
   %D%/packages/patches/icecat-102-makeicecat.patch		\
   %D%/packages/patches/icecat-avoid-bundled-libraries.patch	\
+  %D%/packages/patches/icecat-compare-canonicalized-paths.patch	\
+  %D%/packages/patches/icecat-use-guix-extensions.patch		\
   %D%/packages/patches/icecat-use-system-graphite2+harfbuzz.patch	\
   %D%/packages/patches/icecat-use-system-media-libs.patch	\
   %D%/packages/patches/icedtea-7-hotspot-aarch64-use-c++98.patch	\
diff --git a/gnu/packages/browser-extensions.scm b/gnu/packages/browser-extensions.scm
index 3f6da8d77a3f..8a76f3a3e042 100644
--- a/gnu/packages/browser-extensions.scm
+++ b/gnu/packages/browser-extensions.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright © 2020, 2021 Marius Bakke <marius@gnu.org>
 ;;; Copyright © 2023 Nicolas Graves <ngraves@ngraves.fr>
+;;; Copyright © 2023 Clément Lassieur <clement@lassieur.org>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -25,6 +26,7 @@ (define-module (gnu packages browser-extensions)
   #:use-module (guix build-system gnu)
   #:use-module ((guix licenses) #:prefix license:)
   #:use-module (gnu build chromium-extension)
+  #:use-module (gnu build icecat-extension)
   #:use-module (gnu packages compression)
   #:use-module (gnu packages python))
 
@@ -98,6 +100,7 @@ (define ublock-origin
                 "1i8rnij3sbwg6vj6znprrsca0n5xjzhmhppaa8v6jyxg6wrrfch1"))))
     (build-system gnu-build-system)
     (outputs '("xpi" "firefox" "chromium"))
+    (properties '((id . "uBlock0@raymondhill.net")))
     (arguments
      (list
       #:tests? #f                      ;no tests
@@ -125,9 +128,10 @@ (define ublock-origin
               (invoke "./tools/make-chromium.sh")))
           (add-after 'build-chromium 'install
             (lambda* (#:key outputs #:allow-other-keys)
-              (let ((firefox (assoc-ref outputs "firefox"))
-                    (xpi (assoc-ref outputs "xpi"))
-                    (chromium (assoc-ref outputs "chromium")))
+              (let* ((id #$(assq-ref (package-properties this-package) 'id))
+                     (firefox (in-vicinity (assoc-ref outputs "firefox") id))
+                     (xpi (assoc-ref outputs "xpi"))
+                     (chromium (assoc-ref outputs "chromium")))
                 (install-file "dist/build/uBlock0.firefox.xpi"
                               (string-append xpi "/lib/mozilla/extensions"))
                 (copy-recursively "dist/build/uBlock0.firefox" firefox)
@@ -142,3 +146,6 @@ (define ublock-origin
 
 (define-public ublock-origin/chromium
   (make-chromium-extension ublock-origin "chromium"))
+
+(define-public ublock-origin/icecat
+  (make-icecat-extension ublock-origin "firefox"))
diff --git a/gnu/packages/gnuzilla.scm b/gnu/packages/gnuzilla.scm
index ab629afd3d20..1ef30498e49c 100644
--- a/gnu/packages/gnuzilla.scm
+++ b/gnu/packages/gnuzilla.scm
@@ -5,7 +5,7 @@
 ;;; Copyright © 2015 Sou Bunnbu <iyzsong@gmail.com>
 ;;; Copyright © 2016, 2017, 2018, 2019, 2021 Efraim Flashner <efraim@flashner.co.il>
 ;;; Copyright © 2016 Alex Griffin <a@ajgrf.com>
-;;; Copyright © 2017 Clément Lassieur <clement@lassieur.org>
+;;; Copyright © 2017, 2023 Clément Lassieur <clement@lassieur.org>
 ;;; Copyright © 2017, 2018 Nikita <nikita@n0.is>
 ;;; Copyright © 2017, 2018, 2020 Tobias Geerinckx-Rice <me@tobias.gr>
 ;;; Copyright © 2018, 2020 Ricardo Wurmus <rekado@elephly.net>
@@ -880,16 +880,13 @@ (define-public icecat-minimal
       #:phases
       #~(modify-phases %standard-phases
           (add-after 'unpack 'apply-guix-specific-patches
-            (lambda* (#:key inputs native-inputs #:allow-other-keys)
-              (let ((patch (search-input-file inputs "bin/patch")))
-                (for-each (match-lambda
-                            ((label . file)
-                             (when (and (string-prefix? "icecat-" label)
-                                        (string-suffix? ".patch" label))
-                               (format #t "applying '~a'...~%" file)
-                               (invoke patch "--force" "--no-backup-if-mismatch"
-                                       "-p1" "--input" file))))
-                          (or native-inputs inputs)))))
+            (lambda _
+              (for-each
+               (lambda (file) (invoke "patch" "--force" "-p1" "-i" file))
+               '(#$(local-file
+                    (search-patch "icecat-compare-canonicalized-paths.patch"))
+                 #$(local-file
+                    (search-patch "icecat-use-guix-extensions.patch"))))))
           (add-after 'apply-guix-specific-patches 'remove-bundled-libraries
             (lambda _
               ;; Remove bundled libraries that we don't use, since they may
diff --git a/gnu/packages/patches/icecat-compare-canonicalized-paths.patch b/gnu/packages/patches/icecat-compare-canonicalized-paths.patch
new file mode 100644
index 000000000000..f0130062624b
--- /dev/null
+++ b/gnu/packages/patches/icecat-compare-canonicalized-paths.patch
@@ -0,0 +1,33 @@
+--- a/toolkit/mozapps/extensions/internal/XPIDatabase.jsm
++++ b/toolkit/mozapps/extensions/internal/XPIDatabase.jsm
+@@ -3452,6 +3452,7 @@ const XPIDatabaseReconcile = {
+     if (
+       newAddon ||
+       oldAddon.updateDate != xpiState.mtime ||
++      oldAddon.path != xpiState.path ||
+       (aUpdateCompatibility && this.isAppBundledLocation(installLocation))
+     ) {
+       newAddon = this.updateMetadata(
+@@ -3460,8 +3461,6 @@ const XPIDatabaseReconcile = {
+         xpiState,
+         newAddon
+       );
+-    } else if (oldAddon.path != xpiState.path) {
+-      newAddon = this.updatePath(installLocation, oldAddon, xpiState);
+     } else if (aUpdateCompatibility || aSchemaChange) {
+       newAddon = this.updateCompatibility(
+         installLocation,
+--- a/toolkit/mozapps/extensions/internal/XPIProvider.jsm
++++ b/toolkit/mozapps/extensions/internal/XPIProvider.jsm
+@@ -1167,8 +1167,9 @@ class SystemAddonDefaults extends DirectoryLocation {
+ 
+       // Only attempt to load unpacked directory if unofficial build.
+       if (!AppConstants.MOZILLA_OFFICIAL && !file.exists()) {
+-        file = this.dir.clone();
+-        file.append(`${id}`);
++        let symlink = this.dir.clone();
++        symlink.append(`${id}`);
++        file = symlink.isSymlink() ? new nsIFile(symlink.target) : symlink;
+       }
+ 
+       addons.set(id, file);
diff --git a/gnu/packages/patches/icecat-use-guix-extensions.patch b/gnu/packages/patches/icecat-use-guix-extensions.patch
new file mode 100644
index 000000000000..0d90ea98b685
--- /dev/null
+++ b/gnu/packages/patches/icecat-use-guix-extensions.patch
@@ -0,0 +1,30 @@
+--- a/toolkit/xre/nsXREDirProvider.cpp
++++ b/toolkit/xre/nsXREDirProvider.cpp
+@@ -415,13 +415,20 @@ nsXREDirProvider::GetFile(const char* aProperty, bool* aPersistent,
+ #if defined(XP_UNIX) && !defined(XP_MACOSX)
+   else if (!strcmp(aProperty, XRE_SYS_SHARE_EXTENSION_PARENT_DIR)) {
+ #  ifdef ENABLE_SYSTEM_EXTENSION_DIRS
+-#    if defined(__OpenBSD__) || defined(__FreeBSD__)
+-    static const char* const sysLExtDir = "/usr/local/share/mozilla/extensions";
+-#    else
+-    static const char* const sysLExtDir = "/usr/share/mozilla/extensions";
+-#    endif
+-    rv = NS_NewNativeLocalFile(nsDependentCString(sysLExtDir), false,
+-                               getter_AddRefs(file));
++    rv = GetUserDataDirectoryHome(getter_AddRefs(file), false);
++    NS_ENSURE_SUCCESS(rv, rv);
++
++    rv = file->AppendNative(".guix-profile"_ns);
++    NS_ENSURE_SUCCESS(rv, rv);
++
++    rv = file->AppendNative("share"_ns);
++    NS_ENSURE_SUCCESS(rv, rv);
++
++    rv = file->AppendNative("icecat"_ns);
++    NS_ENSURE_SUCCESS(rv, rv);
++
++    rv = file->AppendNative("extensions"_ns);
++    NS_ENSURE_SUCCESS(rv, rv);
+ #  endif
+   }
+ #endif  // defined(XP_UNIX) && !defined(XP_MACOSX)